
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Retrofit全攻略——基础篇 / 憋错料</title>

    <meta name="description" content="Retrofit全攻略——基础篇 实际开发过程中一般都会选择一些网络框架提升开发效率.随着Google对HttpClient 摒弃和Volley框架的逐渐没落.OkHttp開始异军突起.而Retrofit则对OkHttp进行了强制依赖,能够简单理解Retroifit在OKHttp基础上进一步完好. Retrofit是由Square公司出品的针对于Android和Java的类型安全的Httpclient,眼下推出了2.0+的版本号. Retrofit框架项目地址:https://github.com/square/retrofit">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Retrofit全攻略——基础篇</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>实际开发过程中一般都会选择一些网络框架提升开发效率。随着Google对HttpClient 摒弃和Volley框架的逐渐没落。OkHttp開始异军突起。而Retrofit则对OkHttp进行了强制依赖，能够简单理解Retroifit在OKHttp基础上进一步完好。</p>
<blockquote><p>Retrofit是由<a href="https://github.com/square" rel="external nofollow noreferrer">Square</a>公司出品的针对于Android和Java的类型安全的Httpclient，眼下推出了2.0+的版本号。</p></blockquote>
<p>Retrofit框架项目地址：<a href="https://github.com/square/retrofit" rel="external nofollow noreferrer">https://github.com/square/retrofit</a>。</p>
<p>Retrofit官方文档地址: <a href="http://square.github.io/retrofit/" rel="external nofollow noreferrer">http://square.github.io/retrofit/</a></p>
<h2>使用Retrofit</h2>
<p>接下来我们来学习下怎样使用Retrofit。</p>
<p>首先须要在app/build.gradle加入依赖。</p>
<pre><code>dependencies {
    //...
    //retrofit
    compile ‘com.squareup.retrofit2:retrofit:2.1.0‘
    //假设用到gson解析 须要加入以下的依赖
    compile ‘com.squareup.retrofit2:converter-gson:2.1.0‘
}</code></pre>
<p>我们以查号码归属地接口为例 <a href="https://www.juhe.cn/docs/api/id/11" rel="external nofollow noreferrer">https://www.juhe.cn/docs/api/id/11</a></p>
<p>Retrofit不能直接使用，须要进行初始化，在这里创建NetWork.java</p>
<pre><code>public class NetWork {
    private static Retrofit retrofit;

    /**返回Retrofit*/
    public static Retrofit getRetrofit(){
        if(retrofit==null){
            Retrofit.Builder builder = new Retrofit.Builder();//创建Retrfit构建器
            retrofit = builder.baseUrl("http://apis.juhe.cn/") //指定网络请求的baseUrl
                    .addConverterFactory(GsonConverterFactory.create())//返回的数据通过Gson解析
                    .build();
        }
        return retrofit;
    }
}</code></pre>
<blockquote><p>Retrofit须要之地baseUrl。往往一个项目中有很多接口。接口都使用同样的server地址，这时候能够把接口地址同样的部分抽取到baseUrl中。Retrofit扩展性极好。能够指定返回的数据通过Gson解析，前提你须要保证项目中有Gson框架和com.squareup.retrofit2:converter-gson:2.1.0的依赖。</p></blockquote>
<p>除了通过Gson解析还能够使用其他的方式解析，须要的依赖也不同。有例如以下几种：</p>
<ul>
<li>Gson: com.squareup.retrofit:converter-gson</li>
<li>Jackson: com.squareup.retrofit:converter-jackson</li>
<li>Moshi: com.squareup.retrofit:converter-moshi</li>
<li>Protobuf: com.squareup.retrofit:converter-protobuf</li>
<li>Wire: com.squareup.retrofit:converter-wire</li>
<li>Simple XML: com.squareup.retrofit:converter-simplexml</li>
</ul>
<blockquote><p>Retrofit须要把Http的请求接口封装到一个接口文件里。</p></blockquote>
<pre><code>public interface NetInterface {
    //获取号码归属地，返回来类型是Bean, 须要两个參数分别为phone何key
    @GET("mobile/get")
    Call&lt;Bean&gt; getAddress(@Query("phone") String phone, @Query("key") String key);
}</code></pre>
<p>当中Bean是依据请求的结果创建的对象.</p>
<p>方法前加入@GET注解表示当前请求是Get方式请求，链接的地址是baseUrl+”mobile/get”。baseUrl在初始化Retrofit的时候指定了，拼到一起就是 <a href="http://apis.juhe.cn/mobile/get" rel="external nofollow noreferrer">http://apis.juhe.cn/mobile/get</a>。</p>
<p>对于 Retrofit 2.0中新的URL定义方式，这里是我的建议：</p>
<ul>
<li>baseUrl: 总是以 /结尾</li>
<li>url: 不要以 / 开头</li>
</ul>
<p>由于假设不是这样的方式，拼装后的结果和你期望的是不一样的，详情參考官方文档。</p>
<blockquote><p>除了Get请求还有以下几种请求方式</p></blockquote>
<ul>
<li>@POST    表明这是post请求</li>
<li>@PUT    表明这是put请求</li>
<li>@DELETE    表明这是delete请求</li>
<li>@PATCH    表明这是一个patch请求。该请求是对put请求的补充。用于更新局部资源</li>
<li>@HEAD    表明这是一个head请求</li>
<li>@OPTIONS    表明这是一个option请求</li>
<li>@HTTP    通用注解,能够替换以上全部的注解。其拥有三个属性：method。path，hasBody</li>
</ul>
<p>最后的HTTP通用注解写法比較特殊。请求能够取代之前的请求。以下的写法和之前的@GET效果是一样的。</p>
<pre><code>/**
 * method 表示请的方法，不区分大写和小写
 * path表示路径
 * hasBody表示是否有请求体
 */
@HTTP(method = "get",path = "mobile/get",hasBody = false)
Call&lt;Bean&gt; getAddress(@Query("phone") String phone, @Query("key") String key);</code></pre>
<p>@Quert表示查询參数。用于GET查询，注解里的字符串是參数的key值，參数会自己主动拼装到Url后面。</p>
<p>除了上面的注解。再给大家介绍几种不同的注解。</p>
<h2>经常使用的注解</h2>
<p>@Url：使用全路径复写baseUrl，适用于非统一baseUrl的场景。演示样例代码：</p>
<pre><code>@GET Call&lt;ResponseBody&gt; XXX(@Url String url);</code></pre>
<p>@Streaming:用于下载大文件。演示样例代码：</p>
<pre><code>@Streaming @GET Call&lt;ResponseBody&gt; downloadFileWithDynamicUrlAsync(@Url String fileUrl);

//获取数据的代码
ResponseBody body = response.body();
long fileSize = body.contentLength();
InputStream inputStream = body.byteStream();</code></pre>
<p>@Path：URL占位符，用于替换和动态更新,相应的參数必须使用同样的字符串被@Path进行凝视</p>
<pre><code>//实际请求地址会给句groupId的值发生变化--&gt; http://baseurl/group/groupId/users
@GET("group/{id}/users") Call&lt;List&lt;User&gt;&gt; groupList(@Path("id") int groupId);</code></pre>
<p>@QueryMap:查询參数，和@Query相似。差别就是后面须要Map集合參数。演示样例代码：</p>
<pre><code>Call&lt;List&lt;News&gt;&gt; getNews((@QueryMap(encoded=true) Map&lt;String, String&gt; options);</code></pre>
<p>@Body:用于POST请求体。将实例对象依据转换方式转换为相应的json字符串參数。这个转化方式是GsonConverterFactory定义的。 演示样例代码：</p>
<pre><code>@POST("add")
Call&lt;List&lt;User&gt;&gt; addUser(@Body User user);</code></pre>
<p>@Field，@FieldMap:Post方式传递简单的键值对，须要加入@FormUrlEncoded表示表单提交</p>
<pre><code>@FormUrlEncoded @POST("user/edit") Call&lt;User&gt; updateUser(@Field("first_name") String first, @Field("last_name") String last);</code></pre>
<p>@Part，@PartMap：用于POST文件上传，当中@Part MultipartBody.Part代表文件，@Part(“key”) RequestBody代表參数，须要加入@Multipart表示支持文件上传的表单。</p>
<pre><code>@Multipart
   @POST("upload")
   Call&lt;ResponseBody&gt; upload(@Part("description") RequestBody description,
                             @Part MultipartBody.Part file);</code></pre>
<h2>完毕请求实例</h2>
<p>了解了Retrofit，我们用Retrofit请求完毕请求。Retrofit使用起来比較省事，核心代码例如以下所看到的：</p>
<pre><code>//初始化Retrofit,载入接口
NetInterface netInterface = NetWork.getRetrofit().create(NetInterface.class);
//请求接口
netInterface.getAddress(editText.getText().toString(),"你的app key")
        .enqueue(new Callback&lt;Bean&gt;() {
            @Override
            public void onResponse(Call&lt;Bean&gt; call, Response&lt;Bean&gt; response) {
                //请求成功
                Bean bean = response.body();
                //...
            }

            @Override
            public void onFailure(Call&lt;Bean&gt; call, Throwable t) {
                //请求失败
            }
        });
</code></pre>
<p>Retrofit会自己主动在子线程中进行网络请求。请求结束切换到主线程中。并且内部使用了线程池。对网络请求的缓存控制的也很到位，网络响应速度也是很快的，使用起来很的爽!</p>
<h2>RxJava和Retrofit结合</h2>
<blockquote><p>RxJava很强大。就连Retrofit都要抱下他的大腿，Retrofit也能够用RxJava方式进行网络请求。仅仅须要对上面的代码进行改造就可以。</p></blockquote>
<p>首先加入框架依赖。</p>
<pre><code>dependencies {
  //...

    compile ‘io.reactivex:rxandroid:1.2.1‘
    compile ‘io.reactivex:rxjava:1.1.6‘

    compile ‘com.google.code.gson:gson:2.8.0‘

    compile ‘com.squareup.retrofit2:retrofit:2.1.0‘
    //假设用到gson解析 须要加入以下的依赖
    compile ‘com.squareup.retrofit2:converter-gson:2.1.0‘
    //Retrofit使用RxJava须要的依赖
    compile ‘com.squareup.retrofit2:adapter-rxjava:2.1.0‘

}
</code></pre>
<p>改动Retrofit初始化的代码:</p>
<pre><code>public class NetWork {
    private static Retrofit retrofit;

    /**返回Retrofit*/
    public static Retrofit getRetrofit(){
        if(retrofit==null){
            //创建Retrfit构建器
            Retrofit.Builder builder = new Retrofit.Builder();
            //指定网络请求的baseUrl
            retrofit = builder.baseUrl("http://apis.juhe.cn/")
                    //返回的数据通过Gson解析
                    .addConverterFactory(GsonConverterFactory.create())
                    //使用RxJava模式
                    .addCallAdapterFactory(RxJavaCallAdapterFactory.create())
                    .build();
        }
        return retrofit;
    }
}</code></pre>
<p>上面代码我们通过，加入代码<code>addCallAdapterFactory(RxJavaCallAdapterFactory.create())</code>就变成了使用RxJava模式。</p>
<p>接口也须要改动,把方法的返回值类型由Call改成了RxJava中的Observable。</p>
<pre><code>public interface NetInterface {
    //获取号码归属地，返回来类型是Bean, 须要两个參数分别为phone何key
    @GET("mobile/get")
    Observable&lt;Bean&gt; getAddress(@Query("phone") String phone, @Query("key") String key);
}</code></pre>
<p>接下来改动终于网络请求的代码，能够改成RxJava方式了。</p>
<pre><code>  NetInterface netInterface = NetWork.getRetrofit().create(NetInterface.class);
    //RxJava方式
    netInterface.getAddress(editText.getText().toString(),"你的app key")
            .subscribeOn(Schedulers.io())//设置网络请求在子线程中
            .observeOn(AndroidSchedulers.mainThread())// 回调在主线程中
            .subscribe(new Action1&lt;Bean&gt;() {
                @Override
                public void call(Bean bean) {
                    //请求成功
                }
            }, new Action1&lt;Throwable&gt;() {
                @Override
                public void call(Throwable throwable) {
                    //请求失败
                }
            });</code></pre>
<h2>总结</h2>
<p>这是Retrofit基础篇， 后面有时间再继续深入研究</p>
<hr>
<br />很多其他精彩请关注微信公众账号likeDev</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjEwMDcxMDQzMDk1OTc=.jpg"></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-18 04:37:33 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/app/" title="app">app</a>, <a href="https://www.biecuoliao.com/tag/list/" title="list">list</a>, <a href="https://www.biecuoliao.com/tag/actor/" title="actor">actor</a>, <a href="https://www.biecuoliao.com/tag/err/" title="err">err</a>, <a href="https://www.biecuoliao.com/tag/hub/" title="hub">hub</a>, <a href="https://www.biecuoliao.com/tag/first/" title="first">first</a>, <a href="https://www.biecuoliao.com/tag/%e6%9f%a5%e8%af%a2/" title="查询">查询</a>, <a href="https://www.biecuoliao.com/tag/pop/" title="pop">pop</a>, <a href="https://www.biecuoliao.com/tag/%e8%a1%a5%e5%85%85/" title="补充">补充</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Retrofit全攻略——基础篇的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MXDXBGM.html" rel="bookmark">Retrofit全攻略&mdash;&mdash;进阶篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				最近事比较多,距离上次写文章已经过去了一个月了.上一篇文章Retrofit全攻略--基础篇 介绍了Retrofit的基础用法,这篇文章介绍点进阶的用法. 打印网络日志 在开发阶段,为了方便调试,我们需要查看网络日志.因为Retrofit2.0+底层是采用的OKHttp请求的.可以给OKHttp设置拦截器,用来打印日志. 首先可以在app/build.gradle中添加依赖,这是官方的日志拦截器. compile 'com.squareup.okhttp3:logging-interceptor:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4QzN2EM.html" rel="bookmark">独孤九篇之运维进阶：文件共享服务全攻略完结篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.了解一下 1.NFS NFS(Network File System)即网络文件系统,是FreeBSD支持的文件系统中的一种,它允许网络中的计算机之间通过TCP/IP网络共享资源.在NFS的应用中,本地NFS的客户端应用可以透明地读写位于远端NFS服务器上的文件,就像访问本地文件一样. 好处: 节省本地存储空间,将常用的数据存放在一台NFS服务器上且可以通过网络访问,那么本地终端将可以减少自身存储空间的使用.用户不需要在网络中的每个机器上都建有Home目录,Home目录可以放在NFS服务器上			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4ApEdb3.html" rel="bookmark">FPGA开发全攻略&mdash;&mdash;概念篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文链接: FPGA开发全攻略连载之一:FPGA为什么这么热? FPGA开发全攻略连载之二:为什么工程师要掌握FPGA开发知识? FPGA开发全攻略连载之三:FPGA基本知识与发展趋势(part1) FPGA开发全攻略连载之四:FPGA基本知识与发展趋势(part2) 写在前面 2008年,我参加了几次可编程器件供应商举办的技术研讨会,让我留下深刻印象的是参加这些研讨会的工程师人数之多,简直可以用爆满来形容,很多工程师聚精会神地全天听讲,很少出现吃完午饭就闪人的现象,而且工程师们对研讨会上展出的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0lGjVbM.html" rel="bookmark">前台页面优化全攻略（三）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				经过前两篇文章的实践,你的网站加载速度一定有了非常明显的变化.能把实践跟到这篇文章的人想必一定是极客中的极客.如果你仍对网站的加载速度不满意,可以看看再尝试一下本文中几近疯狂的终极优化方案. 你可以对网站进行快速的优化,但网站日常的节食却很难.也许你已经花了很大的力气去优化你的CSS和JavaScript代码,但是你所做的努力马上又会因为老板或客户期望的新功能而付之东流.所以看来不论是人还是网页,减肥都贵在坚持. 这篇终极减肥方案可能不适合所有的网站,但是我相信它可以引起你对网页大小的重视. 1			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mgl9Eg0.html" rel="bookmark">3D计算机图形学零起点全攻略&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				3D计算机图形学零起点全攻略 这篇文章不包含任何技术知识,但我的希望它能指明一条从零开始通往3D领域的成功之路.我将罗列我看过的相关经典书籍作为学习文献,阅读规则是每进入下个内容,我都会假设已经完成前面全部的文献研习内容.相信若能按照这条路走到最后,会有所进益. 完成整部分内容需要具备基础: 英语:CET4以上 数学:精通数字加减乘除法. 物理:基本力学. 计算机:了解电脑的基本知识,熟练使用Windows. 电脑配置: CPU:双核1.5以上 显卡:NVIDIA GeForce8400G MS			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPDE9aM.html" rel="bookmark">Gradle脚本基础全攻略</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				[工匠若水 http://blog.csdn.net/yanbober 转载请注明出处.点我开始Android技术交流] 1 背景 在开始Gradle之前请务必保证自己已经初步了解了Groovy脚本,特别是闭包规则,如果还不了解Groovy则可以先看&lt;Groovy脚本基础全攻略&gt;这一篇博客速成一下Groovy基础,然后再看此文即可.关于Gradle速成干货基础详情也请参考Geadle官方网站,不好意思我太Low了. Gradle核心是基于Groovy的领域特定语言(DSL,具体概念参见&lt;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MyqvpLM.html" rel="bookmark">&lbrack;037&rsqb; 微信公众帐号开发教程第13篇-图文消息全攻略</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				引言及内容概要 已经有几位读者抱怨“柳峰只用到文本消息作为示例,从来不提图文消息,都不知道图文消息该如何使用”,好吧,我错了,原本以为把基础API封装完.框架搭建好,再给出一个文本消息的使用示例,大家就能够照猫画虎的,或许是因为我的绘画功底太差,画出的那只猫本来就不像猫吧…… 本篇主要介绍微信公众帐号开发中图文消息的使用,以及图文消息的几种表现形式.标题取名为“图文消息全攻略”,这绝对不是标题党,是想借此机会把大家对图文消息相关的问题.疑虑.障碍全部清除掉. 图文消息的主要参数说明 通过微信官方			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eYD7w0.html" rel="bookmark">工欲善其事，必先利其器 之 VS2013全攻略&lpar;安装，技巧，快捷键，插件）！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:工欲善其事,必先利其器 之 VS2013全攻略(安装,技巧,快捷键,插件)! 如有需要WPF工具的朋友可以移步 工欲善其事,必先利其器 之 WPF篇: 随着开发轨迹来看高效WPF开发的工具和技巧 之前一篇&lt;c++的性能, c#的产能?!鱼和熊掌可以兼得,.NET NATIVE初窥&gt;承蒙大家喜爱和编辑推荐,在此非常感谢大家支持.在回复中我发现很多朋友还在使用老的IDE,当然有些是公司决定的,和个人无关.但是有条件的话还是新的IDE比较适合大家,毕竟新的IDE会有新的特性来减少大家编程时间,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzDb1q3.html" rel="bookmark">FPGA开发全攻略&mdash;&mdash;ISE基本操作</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文链接: FPGA实战开发技巧(2) FPGA开发全攻略连载之十二:FPGA实战开发技巧(3) FPGA开发全攻略连载之十二:FPGA实战开发技巧(4) 5.2 如何进行FPGA设计早期系统规划 作者:Ricky Su (www.rickysu.com) 这篇文章讲述了如何用工具提高效率的方法,适用程度因人而异. Situation: 在对FPGA 设计进行最初步的系统规划的时候,需要进行模块划分,模块接口定义等工作.通常,我们起初会在纸上进行设计,到了一定阶段的定稿可能会输入Visio 等工			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M682R53.html" rel="bookmark" class="title">第二个Sprint冲刺第八天</a>
					<div>
						讨论地点:宿舍 讨论成员:邵家文.李新.朱浩龙.陈俊金 工作:更新了主界面					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YGy8r4.html" rel="bookmark" class="title">不知道算不算是自己写出来的 js</a>
					<div>
						最近在写一个小小JS,想了N次,也改了N次,后来不知道为什么,效果就实现了,然后重新看一遍代码,感叹地觉得:原来是这样.那么你们觉得这个代码算是自己写的吗?我觉得是,也觉得不是.是的原因:这程序本身就 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qowJ5M.html" rel="bookmark" class="title">iOS-Senior11-即时通信2&lpar;登录注册界面&rpar;</a>
					<div>
						1.引入文件 1.1步骤 1.2步骤 1.3步骤 1.1用storyboard布局 登录界面两个textField,两个button,输入用户名和密码,点击登录,链接服务器成功,并认证成功,点击注册, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVYP6y4.html" rel="bookmark" class="title">14牡丹江现场赛K zoj3829 Known Notation</a>
					<div>
						Known Notation Time Limit: 2 Seconds      Memory Limit: 65536 KB Do you know reverse Polish notation ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MomkVP3.html" rel="bookmark" class="title">Atitit&period;复合文档的格式&amp;&num;160&semi;标准化格式</a>
					<div>
						Atitit.复合文档的格式 标准化格式 1. Docfile1 2. Iso   Cdf  cd file1 3. Zip1 4. Ooxml1 5. Odf  :OpenDocument Form ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KBqpLM.html" rel="bookmark" class="title">I&period;MX6Q平台Eclipse平台连接不上设备</a>
					<div>
						============问题描述============ 如题 开发环境:win7(64位)+Eclipse 硬件环境:I.MX6Q 开发板系统:Android4.2 在命令提示符下面是这个现象: 在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02k2NA3.html" rel="bookmark" class="title">社交电商要攻克电商堡垒，需要什么？</a>
					<div>
						现如今,包括微博.微信等社交产品也在积极布局电商领域,微信方面推出了微信支付和微店,而微博在年初上线了&quot;支付&quot;产品,随后又尝试售卖多种商品,最近微博甚至试水汽车销售,并且收效不错. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ey8Pg0.html" rel="bookmark" class="title">逃离华强北后  他们去哪儿？采访身边真实故事&mdash;&mdash;华强北电脑维修 内迁 张家界电脑维修 电子市场电脑维修</a>
					<div>
						采访身边真实故事(店主qq 459255116  电话15674450416 )--华强北电脑维修 内迁 张家界电脑维修 电子市场电脑维修 小张今年26岁,来深圳已经打拼5年了, 原本在深圳华强北做笔 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4A6NDZM.html" rel="bookmark" class="title">2016年12月数据库流行度排行榜</a>
					<div>
						完整排名,本月前20名的排名都没有发生变化,唯一值得注意的是随着RDBMS对nosql的支持,后续两年中mongodb不知道会发生什么样的变化,毕竟这些年来要颠覆RDBMS的忽悠太多,但不少独立的所谓 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YRQpa3.html" rel="bookmark" class="title">esxi&plus;vcenter6&period;0&plus;sql2008安装手册&plus;排错</a>
					<div>
						一.Vsphere ESXI 的安装 首先安装两台ESXi主机,ESXi的安装和5没有大的区别,直接按照提示安装即可,使用VMware-VMvisor-Installer-6.0.0-2159203. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0R7D953.html" rel="bookmark" class="title">machine&lowbar;learning-knn算法具体解释&lpar;近邻算法&rpar;</a>
					<div>
						近邻算法是机器学习算法中的入门算法,该算法用于针对已有数据集对未知数据进行分类. 该算法核心思想是通过计算预測数据与已有数据的相似度猜測结果. 举例: 如果有例如以下一组数据(在下面我们统一把该数据作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ekWBa4.html" rel="bookmark" class="title">angular2-aot-webpack   生产环境下编译angular2</a>
					<div>
						这里讲讲,angular2在生产模式下用webpack2进行打包的方法: //使用rollup打包还是比较坑的,功能及插件上都不如webpack, 关键不支持代码分离,导致angular里的lazy  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBbzyKM.html" rel="bookmark" class="title">关于前端开发的20篇文档与指南</a>
					<div>
						相信在2015年很多这个行业的人都会有这样的两种感受: 真的不知所措,这个行业到底有多少东西需要去学习: 渴望更多,并迫不及待的为接下来的学习寻求一些思想方向. 第一个来自于我们的个人感受,而第二个则 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bReeL0.html" rel="bookmark" class="title">翻转句子中单词的顺序 C语言</a>
					<div>
						输入一个英文句子,翻转句子中单词的顺序,但单词内字符的顺序不变.句子中单词以空格符隔开. 为简单起见,标点符号和普通字母一样处理. 例如将&quot;I am a student&quot;转化为&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3OnEG70.html" rel="bookmark" class="title">Grunt操作指南</a>
					<div>
						首先,在项目的根目录下,创建一个文本文件package.json,指定当前项目所需的模块.下面就是一个例子. ? 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 1 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyBj6n0.html" rel="bookmark" class="title">Linux学习之八--关闭Firewall安装Iptables并配置</a>
					<div>
						CentOS 7.0默认使用的是firewall作为防火墙,这里改为iptables防火墙. 1.关闭firewall: systemctl stop firewalld.service #停止fir ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RmGGYM.html" rel="bookmark" class="title">JS中如何判断null</a>
					<div>
						var exp = null; if (exp == null) { alert(&quot;is null&quot;); } exp 为 undefined 时,也会得到与 null 相同的结果, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4Ny5l63.html" rel="bookmark" class="title">Android活动条&lpar;actionbar&rpar;使用详解&lpar;二&rpar;</a>
					<div>
						  1.使用ActionBar实现Tab导航 使用ActionBar实现Tab导航的思路是:AcitonBar通常与Fragment结合使用实现Tab导航.ActionBar在顶端生成多个Tab标签, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyoX9Y3.html" rel="bookmark" class="title">CentOS修改Mysql字符集</a>
					<div>
						1.mysql&gt;show variables like 'character_set%'; 显示如下: +--------------------------+----------------- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MGeO8A3.html" rel="bookmark" class="title">Dom4J&lowbar;&lowbar;ZZ&lowbar;位置</a>
					<div>
						1. 貌似 MyEclipse里面已经自带 dom4j ... 2. 我的 在dr的代码中 有 dom4j操作的是 : &quot;Code_E\workspace_j2ee_1\zcSvgTpo\s ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
